;(function(win){
    function Player(options){
        var _this = this;
        this.audio = document.querySelector(options.el);  //播放器
        this.options = options;
        this.index=0;  //歌单索引值
        this.url = this.pushUrl(this.options);  //歌单列表
        
        this.audio.addEventListener('timeupdate',_this.timeupdate.bind(_this))

        this.audio.addEventListener('ended',_this.end.bind(_this))
    }

    Player.prototype.next=function(){  //下一首
        if(this.index==this.url.length-1){
            this.index = 0;
            this.switchIndex(this.index)
            this.play()
            return;
        }
        this.index++;
        this.switchIndex(this.index)
        this.play();
    }

    Player.prototype.timeupdate=function(){  //正在播放
        this.options.playing&&this.options.playing(this.current(),this.duration())
    }

    Player.prototype.current=function(){
        var currentTime = this.audio.currentTime.toFixed(0);
        if(isNaN(currentTime)){
            return 0;
        }else{
            return currentTime;
        }
        
    }

    Player.prototype.duration=function(){
        var duration =  this.audio.duration.toFixed(0);
        if(isNaN(duration)){
            return 0;
        }else{
            return duration;
        }
    }

    Player.prototype.end=function(){ //结束下一首
        this.next();
    }

    Player.prototype.pushUrl=function(obj){  //添加歌曲列表
        if(obj.music instanceof Array){
            this.url = obj.music;
            this.index = obj.index;
            this.switchIndex(this.index||0);

        }else if(typeof obj.music=='undefined'){
            // console.error('url must be array')
            return;
        }else{
            console.error('url must be array')
            return;
        }
        
    }

    Player.prototype.prev=function(){  //上一首

        if(this.index==0){
            this.index=this.url.length-1;
            this.switchIndex(this.index)
            this.play();
            return;
        }
        this.index--;
        this.switchIndex(this.index)
        this.play();
    }

    Player.prototype.switchIndex=function(index){  //切换指定歌曲
        this.audio.src = this.url[index];
    }

    Player.prototype.play=function(){  //播放
        this.audio.play();
    }


    Player.prototype.pause=function(){  //暂停
        this.audio.pause();
    }

    Player.prototype.setTime=function(time){
        this.audio.currentTime = time;
    }



    win.Player = Player;
})(window);